//
//  UITableViewCell+cornerRadius.h
//  SmartLightForBigFish
//
//  Created by coderYK on 2017/11/16.
//  Copyright © 2017年 RD. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface UITableViewCell (cornerRadius)


/**
 section的圆角效果(原理:重绘section中首尾的cell的背景View)

 @param radius 圆角半径
 */
- (void)rds_setCornerRadius:(CGFloat)radius atTableView:(UITableView *)tableView forRowAtIndexPath:(NSIndexPath *)indexPath;

/**
 section底部圆角效果(原理:重绘section中尾的cell的背景View)
 
 @param radius 圆角半径
 */
- (void)rds_setBottomCornerRadius:(CGFloat)radius atTableView:(UITableView *)tableView forRowAtIndexPath:(NSIndexPath *)indexPath;

/**
 为分组的第一个及最后一个cell添加分割线（未实现）

 @param separatorColor 分割线颜色 （默认为tableView.separatorColor）
 */
- (void)rds_addSeparatorForCellAtFirstOrBottomColor:(UIColor *)separatorColor atTableView:(UITableView *)tableView forRowAtIndexPath:(NSIndexPath *)indexPath;

@end
