//
//  UIView+RDSClip.h
//  singleProduct
//
//  Created by coderYK on 2018/4/30.
//  Copyright © 2018年 RDIOT. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface UIView (RDSClip)

typedef enum:NSUInteger{
    
    Corner_Radius_Or_BorderLine_All=0,
    Corner_Radius_Or_BorderLine_UP,
    Corner_Radius_Or_BorderLine_RIGHT,
    Corner_Radius_Or_BorderLine_DOWN,
    Corner_Radius_Or_BorderLine_LEFT,
//    Corner_Radius_Or_BorderLine_Vertical,
//    Corner_Radius_Or_BorderLine_Horizon,
    
} Corner_Radius_Or_BorderLine_TYPE;


/*
 1.设置单边圆角时无法进行borderLine的设置，因为此时borderline会被蒙版遮挡一部分；
 2.四个角圆角时可以同时设置圆角和borderline，此时就是常规的圆角边线的设置方式
 3.用法：直接或者间接继承自UIView的视图都可以进行设置
 */

// 圆角
- (void)rds_setCornerRadiusWithType:(Corner_Radius_Or_BorderLine_TYPE)type Radius:(CGFloat)cornerRadius;

// 边线borderline
- (void)rds_drawBorderLineWithType:(Corner_Radius_Or_BorderLine_TYPE)type lineWidth:(CGFloat)lineWidth lineColor:(UIColor*)lineColor;


/// 设置圆角边框
/// @param cornerRadius 圆角半径
/// @param lineWidth 边框宽度
- (void)rds_setCornerRadius:(CGFloat)cornerRadius borderLineWidth:(CGFloat)lineWidth lineColor:(UIColor*)lineColor;

//

/**
 阴影+圆角

 @param cornerRadius 圆角半径
 @param shadowColor 阴影颜色，默认为黑色
 */
- (void)rds_addShadowAndCornerRadius:(CGFloat)cornerRadius shadowColor:(UIColor *)shadowColor;
- (void)rds_addShadowAndCornerRadius:(CGFloat)cornerRadius shadowOpacity:(float)shadowOpacity shadowRadius:(CGFloat)shadowRadius shadowColor:(UIColor *)shadowColor;
- (void)rds_addCornerRadius:(CGFloat)cornerRadius;

@end
