//
//  WeatherModel.h
//  Temperature
//
//  Created by RD on 2023/4/26.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@class Location,Now;
@interface WeatherModel : NSObject

@property (nonatomic, strong) Location *location;
@property (nonatomic, strong) Now *now;

+ (void)rds_getWeatherFinished:(void(^)(WeatherModel *weather, NSError *error))finished;

@end


@interface Location : NSObject

@property (nonatomic, copy) NSString *country;
@property (nonatomic, copy) NSString *province;
@property (nonatomic, copy) NSString *city;     // 城市
@property (nonatomic, copy) NSString *name;

@end

@interface Now : NSObject

@property (nonatomic, copy) NSString *text;      // 天气
@property (nonatomic, copy) NSString *wind_class;// 风力等级
@property (nonatomic, copy) NSString *wind_dir;  // 风向描述
@property (nonatomic, copy) NSString *uptime;    // 更新时间
@property (nonatomic, copy) NSString *icon_code; // 天气图标编码

@property (nonatomic, assign) int temp;         // 温度
@property (nonatomic, assign) int feels_like;   // 体感温度
@property (nonatomic, assign) int rh;           // 湿度

@end

NS_ASSUME_NONNULL_END
