//
//  JKToast.h
//  JKToast
//
//  Created by Jakey on 14-10-27.
//  Copyright (c)2014年 www.skyfox.org. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#define DEFAULT_DISPLAY_DURATION 2.0f
#define Version_7 ([[[UIDevice currentDevice] systemVersion] floatValue] >= 7.0f)

typedef enum iToastLocal {
    localTop = 1000001,
    localBottom,
    localCenter
}iToastLocal;

@interface JKToast : NSObject {
    NSString *text;
    UILabel *textLab;
    UIButton *contentView;
    CGFloat  duration;
}

+ (void)showTopWithText:(NSString *)text;
+ (void)showBottomWithText:(NSString *)text;
+ (void)showCenterWithText:(NSString *)text;

+ (void)showWithText:(NSString *)text
            local:(iToastLocal)local
            duration:(CGFloat)duration;

+ (void)showWithText:(NSString *)text
           topOffset:(CGFloat)topOffset;
+ (void)showWithText:(NSString *)text
           topOffset:(CGFloat)topOffset
            duration:(CGFloat)duration;

+ (void)showWithText:(NSString *)text
        bottomOffset:(CGFloat)bottomOffset;
+ (void)showWithText:(NSString *)text
        bottomOffset:(CGFloat)bottomOffset
            duration:(CGFloat)duration;

@end
